# -*- coding: utf-8 -*-
#
# Copyright (c) 2018, HILSTER GmbH, Germany - https://hilster.de
# All rights reserved.
#

from __future__ import absolute_import, division, print_function

from .core import __version_info__, __version__

from .core import ByteType, BitType, ByteStruct, BitStruct, DecodeException, ChecksumMismatchException, RegularExpressionMismatchException, OserNode
from .varint import UBVarInt, ULVarInt, SBVarInt, SLVarInt


from .typedef import BDouble, BFloat, BitField, Flag, LDouble, LFloat, Nibble, SBInt16, SBInt32, SBInt64, SBInt8, SLInt16, SLInt32, SLInt64, SLInt8, UBInt16, UBInt32, UBInt64, UBInt8, ULInt16, ULInt32, ULInt64, ULInt8

from .constant import Constant

from .array_type import Array
from .enum import Enum
from .if_ import If
from .if_else import IfElse
from oser.fuzzing import RandomIntegerFuzzingValue, RandomFloatFuzzingValue, \
    RandomBitsFuzzingValue, RandomStringFuzzingValue, RandomBytesFuzzingValue
from .null import Null
from .padding_flag import PaddingFlag
from .padding import Padding
from .nothing import Nothing
from .string import String
from .data import Data
from .switch import Switch
from .value import Value
from .lazy_initialization import Lazy
from .repeat_until import RepeatUntil

from .json_adapter import JSONAdapter
from .protocol_buffers_adapter import ProtocolBuffersAdapter
from .regular_expression_match import RegularExpressionMatch

from .crc import CRCL8, CRCB8, CRCL16, CRCB16, CRCL32, CRCB32, CRCL64, CRCB64

from .util import to_hex

__all__ = [
"__version_info__", "__version__",
"OserNode",
"ByteType", "BitType", "ByteStruct", "BitStruct", "DecodeException", "ChecksumMismatchException", "RegularExpressionMismatchException",
"UBVarInt", "ULVarInt", "SBVarInt", "SLVarInt",
"BDouble", "BFloat", "BitField", "Flag", "LDouble", "LFloat", "Nibble", "SBInt16", "SBInt32", "SBInt64", "SBInt8", "SLInt16", "SLInt32", "SLInt64", "SLInt8", "UBInt16", "UBInt32", "UBInt64", "UBInt8", "ULInt16", "ULInt32", "ULInt64", "ULInt8",
"Constant",
"Array",
"Enum",
"If",
"IfElse",
"RandomIntegerFuzzingValue", "RandomFloatFuzzingValue", "RandomBitsFuzzingValue", "RandomStringFuzzingValue", "RandomBytesFuzzingValue",
"Null",
"PaddingFlag",
"Padding",
"Nothing",
"String",
"Data",
"Switch",
"Value",
"Lazy",
"JSONAdapter",
"ProtocolBuffersAdapter",
"RegularExpressionMatch",
"RepeatUntil",
"CRCL8", "CRCB8", "CRCL16", "CRCB16", "CRCL32", "CRCB32", "CRCL64", "CRCB64",
"to_hex",
]
