# -*- coding: utf-8 -*-
#
# Copyright (c) 2018, HILSTER GmbH, Germany - https://hilster.de
# All rights reserved.
#

from __future__ import absolute_import, division, print_function, unicode_literals

import sys
import argparse
import webbrowser
import os.path
import oser

if sys.argv[0].endswith("__main__.py"):
    sys.argv[0] = "python -m oser"

if sys.argv[0].endswith("oser-script.py"):
    sys.argv[0] = "oser"


def main():
    parser = argparse.ArgumentParser(description='oser (HILSTER GmbH, http://hilster.de)')

    subparsers = parser.add_subparsers(dest="command",
                        help='the command')
    subparsers.required = True

    docsParser = subparsers.add_parser('docs', help='open documents')

    licenseParser = subparsers.add_parser('licenses', help="show open-source licenses")

    versionParser = subparsers.add_parser('version', help="show version")

    args = parser.parse_args()

    if args.command == "docs":
        path_to_docs = os.path.join(os.path.dirname(oser.__file__), "doc", "html", "index.html")
        webbrowser.open("file://"+path_to_docs)

    if args.command == "licenses":
        print(LICENSES)

    if args.command == "version":
        print("oser-" + oser.__version__)

LICENSES = """
Open Source Licenses
====================

The Sodium Crypto library (libsodium-1.0.10, http://libsodium.org)
------------------------------------------------------------------

Copyright (c) 2013-2016
Frank Denis <j at pureftpd dot org>

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
"""

if __name__ == "__main__":
    main()
