# -*- coding: utf-8 -*-
#
# Copyright (c) 2018, HILSTER GmbH, Germany - https://hilster.de
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from __future__ import absolute_import, division, print_function, unicode_literals

from oser.nothing import Nothing
from oser._if_else import IfElse


class If(IfElse):
    """
    ``If`` builds a conditional serializer for boolean conditions that is
    invisible if the condition is ``False``.

    It is an alias for
    ``IfElse(condition=condition, if_true=if_true, if_false=Nothing())``
    """

    def __init__(self, condition, if_true):
        """
        Args:
            condition: the condition which selects the desired values. Can be a callable (e.g. lambda) or a scalar.
            if_true: is used if `condition` is `True`.
        """
        return super(If, self).__init__(condition=condition,
                                        if_true=if_true,
                                        if_false=Nothing())

    def _items(self):
        """
        Return all field names and instances tuples in order as an iterator.
        """
        if self._evaluate_condition() == True:
            for name, item in super(If, self)._items():
                yield name, item
